<script>
  import Starter from './lib/Starter.svelte'
  import Game from './lib/Game.svelte'
  import { initializeBoard, definePlayerTwoType, hasGameEnded } from './helpers'

  // State
  let squares = initializeBoard()
  let playerOneType = undefined
  let isPlayerOneTurn = true
  let endGameMsg = undefined

  const selectType = evt => {
    playerOneType = evt.detail
  }

  const switchPalyer = () => {
    isPlayerOneTurn = !isPlayerOneTurn
  }

  $: playerTowType = definePlayerTwoType(playerOneType)

  const handleClickSquare = evt => {
    const type = isPlayerOneTurn ? playerOneType : playerTowType
    const updatedSquares = squares.map(s => (s.id === evt.detail.id ? { ...s, type } : s))
    squares = updatedSquares

    const endMsg = hasGameEnded(type, updatedSquares, isPlayerOneTurn)
    if (endMsg) {
      endGameMsg = endMsg
      return
    }

    switchPalyer()
  }

  const reset = () => {
    squares = initializeBoard()
    playerOneType = undefined
    isPlayerOneTurn = true
    endGameMsg = undefined
  }
</script>

<main>
  <div class="layout-container">
    <h1>Tic Tac Toe</h1>

    {#if !playerOneType}
      <Starter on:selectType={selectType} />
    {:else}
      <Game on:selectSquare={handleClickSquare} {isPlayerOneTurn} {squares} on:reset={reset} {endGameMsg} />
    {/if}
  </div>
</main>

<style>
  :root {
    font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', 'Helvetica Neue', sans-serif;
  }

  main {
    display: flex;
    justify-content: center;
    align-items: center;
    height: 100vh;
    width: 100vw;
    overflow: hidden;
    color: #006d77;
    background-color: #edf6f9;
  }

  .layout-container {
    width: 600px;
    margin: 0 auto;
    height: 600px;
    background: #ffddd2;
    border-radius: 8px;
  }

  h1 {
    text-align: center;
    font-size: 3rem;
  }
</style>
